#ifndef __NET_VRF_H
#define __NET_VRF_H

#include <linux/types.h>
#include <linux/vrf.h>

struct vrf
{
	struct list_head	list;
	atomic_t		refcnt;
	u32			vrf;
};

struct vrf_ops
{
	struct list_head	list;
	int			family;
	int			(*create)(struct vrf *),
	int			(*remove)(struct vrf *),
	struct module		*owner;
};

static inline void vrf_get(struct vrf *vrf)
{
	atomic_inc(&vrf->refcnt);
}

static inline void vrf_put(struct vrf *vrf)
{
	if (atomic_dec_and_test(&vrf->refcnt))
		kfree(vrf);
}

extern int			vrf_register(struct vrf_ops *);
extern int			vrf_unregister(struct vrf_ops *);
#endif
